// SpringProxCtl.h

#pragma once
#include "resource.h"
#include <atlctl.h>
#include "SpringProxActiveX.h"

/***********************************************************************************************/
class ATL_NO_VTABLE CSpringProxActiveXCtl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISpringProxActiveXCtl, &IID_ISpringProxActiveXCtl, &LIBID_SpringProxActiveXLib, /*wMajor =*/ 1, /*wMinor =*/ 0>,
	public IPersistStreamInitImpl<CSpringProxActiveXCtl>,
	public IOleControlImpl<CSpringProxActiveXCtl>,
	public IOleObjectImpl<CSpringProxActiveXCtl>,
	public IOleInPlaceActiveObjectImpl<CSpringProxActiveXCtl>,
	public IViewObjectExImpl<CSpringProxActiveXCtl>,
	public IOleInPlaceObjectWindowlessImpl<CSpringProxActiveXCtl>,
	public ISupportErrorInfo,
	public IPersistStorageImpl<CSpringProxActiveXCtl>,
	public ISpecifyPropertyPagesImpl<CSpringProxActiveXCtl>,
	public IQuickActivateImpl<CSpringProxActiveXCtl>,
	public IDataObjectImpl<CSpringProxActiveXCtl>,
	public IProvideClassInfo2Impl<&CLSID_SpringProxActiveXCtl, NULL, &LIBID_SpringProxActiveXLib>,
	public CComCoClass<CSpringProxActiveXCtl, &CLSID_SpringProxActiveXCtl>,
	public CComControl<CSpringProxActiveXCtl>,
	public IObjectSafetyImpl<CSpringProxActiveXCtl, INTERFACESAFE_FOR_UNTRUSTED_CALLER>
{
public:

	CSpringProxActiveXCtl ();
	~CSpringProxActiveXCtl();

DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE | 
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_CANTLINKINSIDE | 
	OLEMISC_INSIDEOUT | 
	OLEMISC_ACTIVATEWHENVISIBLE | 
	OLEMISC_SETCLIENTSITEFIRST
)

DECLARE_REGISTRY_RESOURCEID(IDR_SPRINGPROXCTL)

BEGIN_COM_MAP(CSpringProxActiveXCtl)
	COM_INTERFACE_ENTRY(ISpringProxActiveXCtl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IObjectSafety)
END_COM_MAP()

BEGIN_PROP_MAP(CSpringProxActiveXCtl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Exemples d'entres
	// PROP_ENTRY("Description de la proprit", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()


BEGIN_MSG_MAP(CSpringProxActiveXCtl)
	CHAIN_MSG_MAP(CComControl<CSpringProxActiveXCtl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()

// Prototypes de gestionnaire:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_ISpringProxActiveXCtl,
		};

		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// ISpringProxCtl
public:
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		return S_OK;
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

	HRESULT FinalConstruct()
	{
		return S_OK;
	}
	
	void FinalRelease() 
	{}

  /* Shared with WinCE implementation */	
	#include "springproxactivexctl_impl.h"


}; // class CSpringProxCtl
/***********************************************************************************************/

OBJECT_ENTRY_AUTO(__uuidof(SpringProxActiveXCtl), CSpringProxActiveXCtl)
