@echo off
pushd %0\..

set OLD_PATH=%PATH%
call V:\Dev\Builder\Win32_i386\setenv
set PATH=V:\Dev\Builder\Tools;%SystemRoot%\system32;%PATH%

set STOP=1
goto :desfire

mkdir ..\..\runimage
mkdir ..\..\runimage\win32_i386
mkdir ..\..\runimage\win32_i386\unicode
mkdir ..\..\runimage\win32_i386\stdcall

:springprox
echo --- SPRINGPROX : WIN32/i386 ---
echo.
make -f Makefile_win32_i386 springprox
if errorlevel 1 goto :make_failed
if not exist ..\..\runimage\win32_i386\springprox.dll goto :file_missing
if .%STOP% == .1 pause

:springprox_ex
echo --- SPRINGPROX/EX : WIN32/i386 ---
echo.
make -f Makefile_win32_i386 springprox_ex
if errorlevel 1 goto :make_failed
if not exist ..\..\runimage\win32_i386\springprox_ex.dll goto :file_missing
if .%STOP% == .1 pause

:desfire
echo --- DESFIRE : WIN32/i386 ---
echo.
make -f Makefile_win32_i386 sprox_desfire
if errorlevel 1 goto :make_failed
if not exist ..\..\runimage\win32_i386\sprox_desfire.dll goto :file_missing
if .%STOP% == .1 pause

:desfire_ex
echo --- DESFIRE/EX : WIN32/i386 ---
echo.
make -f Makefile_win32_i386 sprox_desfire_ex
if errorlevel 1 goto :make_failed
if not exist ..\..\runimage\win32_i386\sprox_desfire_ex.dll goto :file_missing
if .%STOP% == .1 pause

:calypso
echo --- CALYPSO : WIN32/i386 ---
echo.
make -f Makefile_win32_i386 sprox_calypso
if errorlevel 1 goto :make_failed
if not exist ..\..\runimage\win32_i386\sprox_calypso.dll goto :file_missing
if .%STOP% == .1 pause

:calypso_ex
echo --- CALYPSO/EX : WIN32/i386 ---
echo.
make -f Makefile_win32_i386 sprox_calypso_ex
if errorlevel 1 goto :make_failed
if not exist ..\..\runimage\win32_i386\sprox_calypso_ex.dll goto :file_missing
if .%STOP% == .1 pause

echo.
echo **** OK, compilation terminee ****
echo.

if exist ..\clean.no goto :done
if exist ..\clean.yes goto :clean

echo.Ready to clean, Ctrl+C to keep objects
pause

:clean
make -f Makefile_win32_i386 clean
make -f Makefile_win32_i386_unicode clean
make -f Makefile_win32_i386_stdcall clean

goto :done

:make_failed

echo.
echo **** ERREUR DURANT LA COMPILATION ****
echo.
goto :done

:file_missing

echo.
echo **** FICHIER DE SORTIE NON TROUVE ****
echo.
goto :done

:done
pause
rm vc60.pch
rm -Rf BuildTmp

set PATH=%OLD_PATH%

popd


