// SproxTestDlg.h : header file
//

#if !defined(AFX_SPROXTESTDLG_H__B42F7BCE_928A_452D_84DB_76E97D1E1A80__INCLUDED_)
#define AFX_SPROXTESTDLG_H__B42F7BCE_928A_452D_84DB_76E97D1E1A80__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CSproxTestDlg dialog

class CSproxTestDlg : public CDialog
{
// Construction
public:
	CSproxTestDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSproxTestDlg)
	enum { IDD = IDD_SPROXTEST_DIALOG };
	CEdit	m_value_ctrl;
	CButton	m_address_mode;
	CButton	m_mode;
	CButton	m_read;
	CButton	m_address_inc;
	CButton	m_address_dec;
	CButton	m_load_keys;
	CButton	m_halt;
	CButton	m_select_wakeup;
	CButton	m_select_idle;
	CButton	m_select_any;
	CButton	m_close;
	CButton	m_resume;
	CButton	m_pause;
	CButton	m_open;
	CString	m_firmware;
	CString	m_comm;
	CString	m_devsnr;
	CString	m_devtype;
	CString	m_library;
	CString	m_tag_atq;
	CString	m_tag_sak;
	CString	m_tag_snr;
	CString	m_result;
	CString	m_action;
	CString	m_address;
	CString	m_value;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSproxTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
  BOOL reader_open;
  BOOL reader_active;

  BOOL tag_found;

  BYTE tag_snr[12];   /* Current tag Serial NumbeR (or UID) */
  BYTE tag_atq[2];    /* Current tag Answer to Query */
  BYTE tag_sak[1];    /* Current tag Select Acknowledge */

  BYTE tag_type;      /* Recognized tag type */
  BYTE tag_addr;      /* Current address on tag */
  BOOL tag_addr_sect; /* Display/edit mode (sector or block) */


  void UpdateFormState(BOOL working);
  void UpdateTag();
  void UpdateAddress(int what);

  CFont font_value;

	// Generated message map functions
	//{{AFX_MSG(CSproxTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnOpen();
	afx_msg void OnClose();
	afx_msg void OnPause();
	afx_msg void OnResume();
	afx_msg void OnSelectAny();
	afx_msg void OnSelectIdle();
	afx_msg void OnSelectWakeup();
	afx_msg void OnHalt();
	afx_msg void OnLoadKeys();
	afx_msg void OnAddressMode();
	afx_msg void OnAddressDec();
	afx_msg void OnAddressInc();
	afx_msg void OnRead();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SPROXTESTDLG_H__B42F7BCE_928A_452D_84DB_76E97D1E1A80__INCLUDED_)
